﻿using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace FEC_XPOS_LED_Utility
{
    public partial class Form1 : Form
    {
        /*
        [DllImport("fec_xpos_led_dll_64", CharSet = CharSet.Unicode)]
        public static extern bool Init();
        [DllImport("fec_xpos_led_dll_64", CharSet = CharSet.Unicode)]
        public static extern bool DeInit();
        [DllImport("fec_xpos_led_dll_64", CharSet = CharSet.Unicode)]
        public static extern bool SetLED(int color);
        */


        [DllImport("fec_fj6412_led", CharSet = CharSet.Unicode)]
        public static extern bool Init();
        [DllImport("fec_fj6412_led", CharSet = CharSet.Unicode)]
        public static extern bool DeInit();
        [DllImport("fec_fj6412_led", CharSet = CharSet.Unicode)]
        public static extern bool SetLED(int color);


        const int COLOR_LED_OFF = 0;
        const int COLOR_RED = 1;
        const int COLOR_GREEN = 2;
        const int COLOR_BLUE = 3;
        const int COLOR_WHITE = 4;
        const int COLOR_CYAN_BLUE = 5;
        const int COLOR_YELLOW = 6;
        const int COLOR_PURPLE = 7;

        /*
        [DllImport("kernel32.dll")]
        private extern static IntPtr LoadLibrary(String DllName);

        [DllImport("kernel32.dll")]
        private extern static IntPtr GetProcAddress(IntPtr hModule, String ProcName);

        [DllImport("kernel32")]
        private extern static bool FreeLibrary(IntPtr hModule);

        [UnmanagedFunctionPointer(CallingConvention.StdCall)]
        private delegate bool InitType();

        IntPtr hMod;
        */

        public Form1()
        {
            InitializeComponent();
            Init(); // Run Init function in fec_xpos_led_dll to init WinIO

            //hMod = LoadLibrary("WinIo64.dll");
            /*
            hMod = LoadLibrary("fec_xpos_led_dll.dll");

            if (hMod == IntPtr.Zero)
            {
                MessageBox.Show("Can't find fec_xpos_led_dll.dll.\nMake sure the WinIo library files are located in the same directory as your executable file.", "XPOS_LED_Tool", MessageBoxButtons.OK, MessageBoxIcon.Error);
                this.Close();
            }

            IntPtr pFunc = GetProcAddress(hMod, "Init");

            if (pFunc != IntPtr.Zero)
            {
                InitType Init = (InitType)Marshal.GetDelegateForFunctionPointer(pFunc, typeof(InitType));
                bool Result = Init();
                //bool Result = true;

                if (!Result)
                {
                    MessageBox.Show("Error returned from InitializeWinIo.\nMake sure you are running with administrative privileges and that the WinIo library files are located in the same directory as your executable file.", "XPOS_LED_Tool", MessageBoxButtons.OK, MessageBoxIcon.Error);
                    FreeLibrary(hMod);
                    this.Close();
                }
            }
            */
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            var colors = new[] { "Off", "Red", "Green", "Blue", "White", "Cyan Blue", "Yellow", "Purple"};
            cbbColorSelect.DataSource = colors;
            cbbColorSelect.SelectedIndex = 0;

            //Init(); // Run Init function in fec_xpos_led_dll to init WinIO
        }

        private void TurnOnLED_Click(object sender, EventArgs e)
        {
            if(COLOR_LED_OFF == cbbColorSelect.SelectedIndex)
            {
                SetLED(COLOR_LED_OFF);
            }
            else if(COLOR_RED == cbbColorSelect.SelectedIndex)
            {
                SetLED(COLOR_RED);
            }
            else if(COLOR_GREEN == cbbColorSelect.SelectedIndex)
            {
                SetLED(COLOR_GREEN);
            }
            else if (COLOR_BLUE == cbbColorSelect.SelectedIndex)
            {
                SetLED(COLOR_BLUE);
            }
            else if (COLOR_WHITE == cbbColorSelect.SelectedIndex)
            {
                SetLED(COLOR_WHITE);
            }
            else if (COLOR_CYAN_BLUE == cbbColorSelect.SelectedIndex)
            {
                SetLED(COLOR_CYAN_BLUE);
            }
            else if (COLOR_YELLOW == cbbColorSelect.SelectedIndex)
            {
                SetLED(COLOR_YELLOW);
            }
            else if (COLOR_PURPLE == cbbColorSelect.SelectedIndex)
            {
                SetLED(COLOR_PURPLE);
            }
            else
            {
                SetLED(COLOR_LED_OFF);

            }
        }

        private void TurnOffLED_Click(object sender, EventArgs e)
        {
            SetLED(COLOR_LED_OFF);
        }

        private void Exit_Click(object sender, EventArgs e)
        {
            DeInit();
            this.Close();
        }
    }
}
